function F = DGFilters(FSize,NORIENT)

SCALE = 8;                     
NBAR=length(SCALE)*NORIENT;
NF = NBAR;
F=zeros(FSize(1),FSize(2),NF);
ctr = FSize/2+1;
x = -ctr(2)+1:FSize(2)-ctr(2);
y = -ctr(1)+1:FSize(1)-ctr(1);
[x,y] = meshgrid(x,y);
orgpts=[x(:) y(:)]';

count=1;

for orient=0:NORIENT-1,
  angle=pi*orient/NORIENT; 
  c=cos(angle);s=sin(angle);
  rotpts=[c -s;s c]*orgpts;
  F(:,:,count)=normalise(makefilter(SCALE,0,0,rotpts,FSize));
  count=count+1;
end

return

function f=makefilter(scale,phasex,phasey,pts,FSize)
  gx=gauss1d(scale*8,0,pts(1,:),phasex);
  gy=gauss1d(scale/4,0,pts(2,:),phasey);
  f=normalise(reshape(gx.*gy,FSize(1),FSize(2)));
return

function g=gauss1d(sigma,mean,x,ord)
  x=x-mean;num=x.*x;
  variance=sigma^2;
  denom=2*variance; 
  g=exp(-num/denom)/sqrt(pi*denom);
  switch (ord)
    case 1 
        g=-g.*(x/variance);
    case 2
        g=g.*((num-variance)/(variance^2));
  end
return

function f=normalise(f)
    MIN = min(f(:));
    MAX = max(f(:));
    f=(f-MIN)/(MAX-MIN); 
return

